
/* Chrysalide - Outil d'analyse de fichiers binaires
 * hyperscan.h - prototypes pour la méthode de recherche basée sur la bibliothèque Hyperscan d'Intel
 *
 * Copyright (C) 2024 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_SCAN_PATTERNS_BACKENDS_HYPERSCAN_H
#define _ANALYSIS_SCAN_PATTERNS_BACKENDS_HYPERSCAN_H


#include <glib-object.h>
#include <stdbool.h>


#include "../backend.h"



#define G_TYPE_HYPERSCAN_BACKEND            g_hyperscan_backend_get_type()
#define G_HYPERSCAN_BACKEND(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), G_TYPE_HYPERSCAN_BACKEND, GHyperscanBackend))
#define G_IS_HYPERSCAN_BACKEND(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), G_TYPE_HYPERSCAN_BACKEND))
#define G_HYPERSCAN_BACKEND_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_HYPERSCAN_BACKEND, GHyperscanBackendClass))
#define G_IS_HYPERSCAN_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_HYPERSCAN_BACKEND))
#define G_HYPERSCAN_BACKEND_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_HYPERSCAN_BACKEND, GHyperscanBackendClass))


/* Méthode de recherche basée sur une bibliothèque d'Intel : Hyperscan (instance) */
typedef struct _GHyperscanBackend GHyperscanBackend;

/* Méthode de recherche basée sur une bibliothèque d'Intel : Hyperscan (classe) */
typedef struct _GHyperscanBackendClass GHyperscanBackendClass;


/* Indique le type défini pour un moteur de recherche pour données. */
GType g_hyperscan_backend_get_type(void);

/* Crée une méthode de recherche avec la bibliothèque Hyperscan. */
GEngineBackend *g_hyperscan_backend_new(void);



#endif  /* _ANALYSIS_SCAN_PATTERNS_BACKENDS_HYPERSCAN_H */
